﻿Benchmark Production tools alpha
------------------------------------------------
This helps set up a design for benchmarking with negligible overhead.

The payload use case is

    ./bin/x64/factorio --benchmark saves/your.zip --benchmark-ticks 72000 \
    | mods/Benchmark*/annotate-log.awk quiet=1

The main features:

1) a production-and-rail-delivery readout delivered to stdout in
`|`-separated csv format, an awk is included that calculates
production-per-cpu-millisecond figures when fed the output from a
benchmark run.

2) storage-reset facility to hunt up circuit-attached storage and
adjust inventories to bring signal counts on the network to 0. This is
less useful now, with 0.16's infinity chests, but it's still got its
niche if you want to handle fluids or track usage or test load balance.

Circuit-attached storage is reset:
- at stops whose names begin `==>` when a train leaves;
- for the cursor selection with a bare `bp` command
- at `==>…%n` stops every `n` ticks if no train's there

3) `/bp` and `/iod` commands for running arbitrary lua code with `e` and
`p` set to the selected entity and the issuing player, and the
mod's internal functions available.
The `bp` command's default action is a storage reset.

4) `/insta` and `/cheat` commands turn on amplified cheat-mode with instant
blueprints and decon. The `/cheat` mode additionally supplies armor,
exos, research, weaponry, reach/speed boosts, la la.

Overhead when using train-departure storage resets is down in the low
milliseconds per minute even on massive maps.
