-- event-handling utilities
--
-- tracing setup
ename = {} for k,v in next,defines.events do ename[v]=k end
notrace={}
function default_trace(e) print((ename[e.name] or '')..serpent.line(e)) end
--
-- event handling
local bootstraps={init=1,load=1,configuration_changed=1,nth_tick=1}
function on (s,f,...)
    local on_s ='on_'..s
    local e = defines.events[on_s]
    if e then
	notrace[e]=true
	return script.on_event(e,f)
    elseif bootstraps[s] then
	return script[on_s](f,...)
    else -- a custom input or a direct event number
	return script.on_event(s,f)
	end
    end
--[[
on('player_cursor_stack_changed',nil)	    -- sets notrace for evt
on('player_quickbar_inventory_changed',nil)
on('player_main_inventory_changed',nil)
on('player_crafted_item',nil)
on('robot_built_entity',nil)
on('robot_mined',nil)
on('robot_built_tile',nil)
on('robot_mined_tile',nil)
on('selected_entity_changed',nil)
on('entity_died',nil)
on('tick',nil)
--]]
function trace_all_others()
    local maxev=0
    for k,v in next,defines.events do
	if not script.get_event_handler(v)
	and not notrace[v] then
	    script.on_event(v,default_trace)
	    end
	if v>maxev then maxev=v end
	end
    for v=maxev+1,1e9 do
	if not notrace[v] and not script.get_event_handler(v) then
	    if not pcall(script.on_event,v,default_trace) then break end
	    end
	end
    end
